{ ********  160 x 96 High Color 1 byte / Pixel Fractial Display ***********

A quick, fun hack to add some more color to Hanno's Fractal Demo.

Any and all uses permitted, Doug Dingus 2010

}

CON
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

VAR
  byte          displayb[15360]   'allocate display buffer in RAM
                                  '160 x 96 Pixel display
                                  'Driver can go to 320 x 192, limited by Prop RAM 
  long          index             'temp offset for byte statement below

  long          i, j, k, l, m     'misc working vars

  long          stack1[100]       'working stack for computation
  long          stack2[100]
  long          stack3[100]
  long          stack4[100]
  
OBJ
  tv : "160x96_hi-color_NTSC_TV"  'the TV driver
  
PUB start |  pxmin, pxmax, pymin, pymax, pxmid, pymid

    'view the whole set
    pxmin := -2500'-1300
    pymin := -1500'-300
    pxmax :=  1500'-900
    pymax :=  1500'-5

    'one of many interesting zooms into the set

    'pxmin := -1300
    'pymin := -300
    'pxmax := -900
    'pymax := -5   




    

    pxmid := pxmin + ((pxmax - pxmin) / 2)
    pymid := pymin + ((pymax - pymin) / 2)
    
    prep  'draw sane values to display buffer before starting TV COG
        
    tv.start(@displayb)  'start the tv cog & pass it the address of the bitmap

    'do computation for the 4 compute COGS
        
    cognew( fractal(pxmin, pymin, pxmid, pymid, 0, 0, 79, 47), @stack1)             'upper left
    cognew( fractal(pxmid, pymin, pxmax, pymid, 80, 0, 79, 47), @stack2)             'upper right
    cognew( fractal(pxmin, pymid, pxmid, pymax, 0, 48, 79, 47), @stack3)             'lower left
    cognew( fractal(pxmid, pymid, pxmax, pymax, 80, 48, 79, 47), @stack4)           'lower right

    waitcnt(cnt+50_000_000)

    'fractal(pxmin, pymin, pxmax, pymax, 0, 0, 159, 95)  'picture check for entire frame, single cog  

pub plot(px,py,c)
  displayb[py*160+px] := @@clut[c & %01111111]   '128 color CLUT


pub fractal(_xmin, _ymin, _xmax, _ymax, dxoff, dyoff, dxmax, dymax) | xmin, xmax, ymin, ymax, xs, ys, p, q, ii, x, y, xn, y0, x0

  'use integral math- divide by 1000 to get actual value
  'view from (-2.5,-1.5) to (1.5,1.5)
  xmin:=_xmin
  ymin:=_ymin
  xmax:=_xmax 
  ymax:=_ymax
  xs:=(xmax-xmin)/dxmax
  ys:=(ymax-ymin)/dymax

  'loop over x,y
  repeat y from 0 to dymax
   q:=ymin+y*ys
    repeat x from 0 to dxmax
     p:=xmin+x*xs
     xn:=0
     x0:=0
     y0:=0
     repeat ii from 0 to 128
       'quit loop when sqrt(xn^2+y0^2)>2 
       if (xn*xn+y0*y0 > 4_000_000)
         quit
       'calculate z=(zold)^2+c in complex space   
       xn:=(x0+y0)*(x0-y0)/1000+p
       y0:=(x0*y0/500)+q
       x0:=xn
     'plot color at current x,y
     plot(x+dxoff ,y+dyoff ,ii)

PUB  prep

   'fill bitmap with valid pixels, before triggering display there is no Color Lookup
   'Table in the TV driver just yet.
   
    repeat index from 0 to 15360   'size of display buffer 
      byte [@displayb] [index] := @@clut[2]  'There is a CLUT in this program though



DAT
'color lookup table, upper 4 bits hue, lower 4 intensity and saturation
'mixed together.  I've got the high saturation colors mapped to their
'closest hue.

clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07
clut1   byte  byte  $02, $1a, $1b, $1c, $1d, $1e, $98, $af
clut2   byte  byte  $02, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $02, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $02, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $02, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $02, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $02, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $02, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $02, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $02, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $02, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $02, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $02, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $02, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $02, $fa, $fb, $fc, $fd, $fe, $78, $8f

DAT

